var lWarn = {logln:function (o){}}; 
var lInfo = {logln:function (o){}};

var LOGFILE_NAME = "uds-config.log";
lWarn = new Logger(LOGFILE_NAME);
lInfo = new Logger(LOGFILE_NAME);


var Utf8 = {
		 
	    // public method for url encoding
	    encode : function (string) {
	        string = string.replace(/\r\n/g,"\n");
	        var utftext = "";
	 
	        for (var n = 0; n < string.length; n++) {
	 
	            var c = string.charCodeAt(n);
	 
	            if (c < 128) {
	                utftext += String.fromCharCode(c);
	            }
	            else if((c > 127) && (c < 2048)) {
	                utftext += String.fromCharCode((c >> 6) | 192);
	                utftext += String.fromCharCode((c & 63) | 128);
	            }
	            else {
	                utftext += String.fromCharCode((c >> 12) | 224);
	                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
	                utftext += String.fromCharCode((c & 63) | 128);
	            }
	 
	        }
	 
	        return utftext;
	    },
	 
	    // public method for url decoding
	    decode : function (utftext) {
	        var string = "";
	        var i = 0;
	        var c = c1 = c2 = 0;
	 
	        while ( i < utftext.length ) {
	 
	            c = utftext.charCodeAt(i);
	 
	            if (c < 128) {
	                string += String.fromCharCode(c);
	                i++;
	            }
	            else if((c > 191) && (c < 224)) {
	                c2 = utftext.charCodeAt(i+1);
	                string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
	                i += 2;
	            }
	            else {
	                c2 = utftext.charCodeAt(i+1);
	                c3 = utftext.charCodeAt(i+2);
	                string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
	                i += 3;
	            }
	 
	        }
	 
	        return string;
	    }
	 
	};


function storeSubParameter(path, value) {
	lInfo.logln('path: ' + path + ' value: ' + value + '!');
    Property.setProperty('/scripts/system-addon-user-defined-states/' + path, value);
    Property.setFlag('/scripts/system-addon-user-defined-states/' + path, 'ARCHIVE', true);
}

function getNewIdValue() {
    var idValue = Math.floor(new Date().getTime()/1000);
    var baseNode = Property.getNode('/scripts/system-addon-user-defined-states/custom-states');
    if (baseNode != null) {
	    var oArrayNode = baseNode.getChildren();
	    for ( var iIndex = 0; iIndex < oArrayNode.length; iIndex++) {
	        var oChildNode = oArrayNode[iIndex];
	        if (oChildNode.getChild('id') != null)
	            if (oChildNode.getChild('id').getValue() != null)
	                if (parseInt("" + oChildNode.getChild('id').getValue(),10) >= idValue)
	                    idValue = parseInt("" + oChildNode.getChild('id').getValue(),10) + 1;
	    }
    }
    var baseNode = Property.getNode('/scripts/system-addon-user-defined-states/triggered-states');
    if (baseNode != null) {
	    var oArrayNode = baseNode.getChildren();
	    for ( var iIndex = 0; iIndex < oArrayNode.length; iIndex++) {
	        var oChildNode = oArrayNode[iIndex];
	        if (oChildNode.getChild('id') != null)
	            if (oChildNode.getChild('id').getValue() != null)
	                if (parseInt("" + oChildNode.getChild('id').getValue(),10) >= idValue)
	                    idValue = parseInt("" + oChildNode.getChild('id').getValue(),10) + 1;
	    }
    }
    return idValue;
}

function triggeredStates(oParameterObject,esName) {
    storeSubParameter('triggered-states/' + esName + '/name', Utf8.encode(unescape(oParameterObject.name)));
    storeSubParameter('triggered-states/' + esName + '/setName', Utf8.encode(unescape(oParameterObject.setName)));
    storeSubParameter('triggered-states/' + esName + '/resetName', Utf8.encode(unescape(oParameterObject.resetName)));
    storeSubParameter('triggered-states/' + esName + '/showOnPhone', oParameterObject.showOnPhone);
    storeSubParameter('triggered-states/' + esName + '/id', esName);
    
    putTriggerParameter('triggered-states/' + esName + '/setTrigger',{triggers:oParameterObject.activityState.setTrigger});
    putTriggerParameter('triggered-states/' + esName + '/resetTrigger',{triggers:oParameterObject.activityState.resetTrigger});
    
    storeSubParameter('triggered-states/' + esName + '/setTrigger/actions/0/statename','' + esName);
    storeSubParameter('triggered-states/' + esName + '/setTrigger/actions/0/type','change-addon-state');
    storeSubParameter('triggered-states/' + esName + '/setTrigger/actions/0/addon-id','system-addon-user-defined-states');
	storeSubParameter('triggered-states/' + esName + '/setTrigger/actions/0/state','active');
	storeSubParameter('triggered-states/' + esName + '/setTrigger/actions/0/delay',0);

	storeSubParameter('triggered-states/' + esName + '/resetTrigger/actions/0/statename','' + esName);
	storeSubParameter('triggered-states/' + esName + '/resetTrigger/actions/0/type','change-addon-state');
	storeSubParameter('triggered-states/' + esName + '/resetTrigger/actions/0/addon-id','system-addon-user-defined-states');
	storeSubParameter('triggered-states/' + esName + '/resetTrigger/actions/0/state','inactive');
	storeSubParameter('triggered-states/' + esName + '/resetTrigger/actions/0/delay',0);

	if (oParameterObject.activityState.setRetriggeringLag>0) {	
		storeSubParameter('triggered-states/' + esName + '/setTrigger/damping/interval',oParameterObject.activityState.setRetriggeringLag);
		storeSubParameter('triggered-states/' + esName + '/setTrigger/damping/rewindTimer',true);
		storeSubParameter('triggered-states/' + esName + '/setTrigger/lag/delay',oParameterObject.activityState.setRetriggeringLag);
		storeSubParameter('triggered-states/' + esName + '/setTrigger/lag/reschedule',true);		
	}

	if (oParameterObject.activityState.resetRetriggeringLag>0) {
		storeSubParameter('triggered-states/' + esName + '/resetTrigger/damping/interval',oParameterObject.activityState.resetRetriggeringLag);
		storeSubParameter('triggered-states/' + esName + '/resetTrigger/damping/rewindTimer',true);
		storeSubParameter('triggered-states/' + esName + '/resetTrigger/lag/delay',oParameterObject.activityState.resetRetriggeringLag);
		storeSubParameter('triggered-states/' + esName + '/resetTrigger/lag/reschedule',true);		
	}  	
}

function customStates(oParameterObject,esName) {
    storeSubParameter('custom-states/' + esName + '/name', Utf8.encode(unescape(oParameterObject.name)));
    storeSubParameter('custom-states/' + esName + '/setName', Utf8.encode(unescape(oParameterObject.setName)));
    storeSubParameter('custom-states/' + esName + '/resetName', Utf8.encode(unescape(oParameterObject.resetName)));
    storeSubParameter('custom-states/' + esName + '/showOnPhone', oParameterObject.showOnPhone);
    storeSubParameter('custom-states/' + esName + '/id', esName);    
}

function combinateState(oParameterObject,esName) {
    var combinedStates;
    var fOr;
	if (oParameterObject.combinedState.or) {
		fOr=true;
		combinedStates=oParameterObject.combinedState.or;
	}
	if (oParameterObject.combinedState.and) {
		fOr=false;
		combinedStates=oParameterObject.combinedState.and;
	}
	if (combinedStates==null)
		return;

	for (var iIndex=0;iIndex<combinedStates.length;iIndex++) {
		var sStateValue=combinedStates[iIndex].value;
		
		var invertedStateValue="";
		var orCondi;
		var andCondi;
		if (sStateValue==true) {
			invertedStateValue=false;
			orCondi=false;
			andCondi=true;
		}
		if (sStateValue==false) {
			invertedStateValue=true;
			orCondi=true;
			andCondi=false;
		}
		if (sStateValue=='active') {
			invertedStateValue="inactive";
			orCondi=2;
			andCondi=1;
		}
		if (sStateValue=='inactive') {
			invertedStateValue="active";
			orCondi=1;
			andCondi=2;
		}
		if (sStateValue=='on') {
			invertedStateValue="off";
			orCondi="off";
			andCondi="on";
		}
			
		if (sStateValue=='off') {
			invertedStateValue="on";
			orCondi="on";
			andCondi="off";
		}

		if (sStateValue=='present') {
			invertedStateValue="absent";
			orCondi="absent";
			andCondi="present";
		}
		if (sStateValue=='absent') {
			invertedStateValue="present";
			orCondi="present";
			andCondi="absent";
		}
		if (combinedStates[iIndex].addonid=='') {
			var stateName=combinedStates[iIndex].state;
			var stateArray=stateName.split('.');
			var orignalState=sStateValue;
			if (stateArray.length==3)
				if (stateArray[0]=='dev') {
					if (Property.getNode('/apartment/zones/zone0/devices/' + stateArray[1] + '/binaryInputs/binaryInput' + stateArray[2]+"/inputType")!=null) {
						var type=Property.getNode('/apartment/zones/zone0/devices/' + stateArray[1] + '/binaryInputs/binaryInput' + stateArray[2]+"/inputType").getValue();
						if ((type==13) || (type==14) || (type==15)) {
							lInfo.logln('Need a helperstate for ' + combinedStates[iIndex].state);
							var helper='combi_' + stateArray[1] + '_' +  sStateValue;
														
				    		if (sStateValue=='open') {
				    			storeSubParameter('combined-states/' + esName + '/helper/' + iIndex + "/setTrigger/triggers/0/type" , 'state-change');
					    		storeSubParameter('combined-states/' + esName + '/helper/' + iIndex + "/setTrigger/triggers/0/name" , stateName);
					    		storeSubParameter('combined-states/' + esName + '/helper/' + iIndex + "/setTrigger/triggers/0/state" , 'open');
				    		}
				    		if (sStateValue=='closed') { 
				    			storeSubParameter('combined-states/' + esName + '/helper/' + iIndex + "/setTrigger/triggers/0/type" , 'state-change');
					    		storeSubParameter('combined-states/' + esName + '/helper/' + iIndex + "/setTrigger/triggers/0/name" , stateName);
					    		storeSubParameter('combined-states/' + esName + '/helper/' + iIndex + "/setTrigger/triggers/0/state" , 'closed');
				    		}
				    		if (sStateValue=='tilded') {
				    			storeSubParameter('combined-states/' + esName + '/helper/' + iIndex + "/setTrigger/triggers/0/type" , 'state-change');
					    		storeSubParameter('combined-states/' + esName + '/helper/' + iIndex + "/setTrigger/triggers/0/name" , stateName);
					    		storeSubParameter('combined-states/' + esName + '/helper/' + iIndex + "/setTrigger/triggers/0/state" , 'tilded');
				    		}

				    		if (sStateValue=='open') {
				    			storeSubParameter('combined-states/' + esName + '/helper/' + iIndex + "/resetTrigger/triggers/0/type" , 'state-change');
					    		storeSubParameter('combined-states/' + esName + '/helper/' + iIndex + "/resetTrigger/triggers/0/name" , stateName);
					    		storeSubParameter('combined-states/' + esName + '/helper/' + iIndex + "/resetTrigger/triggers/0/state" , 'closed');
				    			storeSubParameter('combined-states/' + esName + '/helper/' + iIndex + "/resetTrigger/triggers/1/type" , 'state-change');
					    		storeSubParameter('combined-states/' + esName + '/helper/' + iIndex + "/resetTrigger/triggers/1/name" , stateName);
					    		storeSubParameter('combined-states/' + esName + '/helper/' + iIndex + "/resetTrigger/triggers/1/state" , 'tilded');
				    		}
				    		if (sStateValue=='closed') { 
				    			storeSubParameter('combined-states/' + esName + '/helper/' + iIndex + "/resetTrigger/triggers/0/type" , 'state-change');
					    		storeSubParameter('combined-states/' + esName + '/helper/' + iIndex + "/resetTrigger/triggers/0/name" , stateName);
					    		storeSubParameter('combined-states/' + esName + '/helper/' + iIndex + "/resetTrigger/triggers/0/state" , 'open');
				    			storeSubParameter('combined-states/' + esName + '/helper/' + iIndex + "/resetTrigger/triggers/1/type" , 'state-change');
					    		storeSubParameter('combined-states/' + esName + '/helper/' + iIndex + "/resetTrigger/triggers/1/name" , stateName);
					    		storeSubParameter('combined-states/' + esName + '/helper/' + iIndex + "/resetTrigger/triggers/1/state" , 'tilded');
				    		}
				    		if (sStateValue=='tilded') {
				    			storeSubParameter('combined-states/' + esName + '/helper/' + iIndex + "/resetTrigger/triggers/0/type" , 'state-change');
					    		storeSubParameter('combined-states/' + esName + '/helper/' + iIndex + "/resetTrigger/triggers/0/name" , stateName);
					    		storeSubParameter('combined-states/' + esName + '/helper/' + iIndex + "/resetTrigger/triggers/0/state" , 'open');
				    			storeSubParameter('combined-states/' + esName + '/helper/' + iIndex + "/resetTrigger/triggers/1/type" , 'state-change');
					    		storeSubParameter('combined-states/' + esName + '/helper/' + iIndex + "/resetTrigger/triggers/1/name" , stateName);
					    		storeSubParameter('combined-states/' + esName + '/helper/' + iIndex + "/resetTrigger/triggers/1/state" , 'closed');
				    		}
				    	    storeSubParameter('combined-states/' + esName + '/helper/' + iIndex + '/setTrigger/actions/0/statename',helper);
				    	    storeSubParameter('combined-states/' + esName + '/helper/' + iIndex + '/setTrigger/actions/0/type','change-addon-state');
				    	    storeSubParameter('combined-states/' + esName + '/helper/' + iIndex + '/setTrigger/actions/0/addon-id','system-addon-user-defined-states-helper');
				    		storeSubParameter('combined-states/' + esName + '/helper/' + iIndex + '/setTrigger/actions/0/state','active');
				    		storeSubParameter('combined-states/' + esName + '/helper/' + iIndex + '/setTrigger/actions/0/delay',0);

				    		storeSubParameter('combined-states/' + esName + '/helper/' + iIndex + '/resetTrigger/actions/0/statename',helper);
				    		storeSubParameter('combined-states/' + esName + '/helper/' + iIndex + '/resetTrigger/actions/0/type','change-addon-state');
				    		storeSubParameter('combined-states/' + esName + '/helper/' + iIndex + '/resetTrigger/actions/0/addon-id','system-addon-user-defined-states-helper');
				    		storeSubParameter('combined-states/' + esName + '/helper/' + iIndex + '/resetTrigger/actions/0/state','inactive');
				    		storeSubParameter('combined-states/' + esName + '/helper/' + iIndex + '/resetTrigger/actions/0/delay',0);
							
							combinedStates[iIndex].addonid='system-addon-user-defined-states-helper';
							combinedStates[iIndex].state=helper;
							sStateValue='active';
							invertedStateValue='inactive';
							orCondi=2;
							andCondi=1;
							
						}
					}
				}
					
		}
		
		if ((combinedStates[iIndex].addonid=='')||(combinedStates[iIndex].addonid=='system-addon-user-defined-states-special')) {
			storeSubParameter('combined-states/' + esName + '/setTrigger/triggers/' +iIndex  + "/type" , "state-change");
			storeSubParameter('combined-states/' + esName + '/resetTrigger/triggers/' +iIndex  + "/type" , "state-change");
		} else  {
			storeSubParameter('combined-states/' + esName + '/setTrigger/triggers/' +iIndex  + "/type" , "addon-state-change");
			storeSubParameter('combined-states/' + esName + '/setTrigger/triggers/' +iIndex  + "/addon-id" , combinedStates[iIndex].addonid);			
			storeSubParameter('combined-states/' + esName + '/resetTrigger/triggers/' +iIndex  + "/type" , "addon-state-change");
			storeSubParameter('combined-states/' + esName + '/resetTrigger/triggers/' +iIndex  + "/addon-id" , combinedStates[iIndex].addonid);			
		}
		
		if (combinedStates[iIndex].addonid=='') {
			if (fOr) {
				storeSubParameter('combined-states/' + esName + '/resetTrigger/conditions/states/' + combinedStates[iIndex].state,orCondi);
			} else {
				storeSubParameter('combined-states/' + esName + '/setTrigger/conditions/states/' + combinedStates[iIndex].state,andCondi);				
			}

		} else  {
			if (combinedStates[iIndex].addonid=='system-addon-user-defined-states-special')
				combinedStates[iIndex].addonid='system-addon-user-defined-states';
			if (fOr) {
				storeSubParameter('combined-states/' + esName + '/resetTrigger/conditions/addon-states/'+combinedStates[iIndex].addonid+ '/' + combinedStates[iIndex].state,orCondi);
			} else {
				storeSubParameter('combined-states/' + esName + '/setTrigger/conditions/addon-states/'+combinedStates[iIndex].addonid+ '/' + combinedStates[iIndex].state,andCondi);				
			}
		} 

		
		storeSubParameter('combined-states/' + esName + '/setTrigger/triggers/' +iIndex  + "/name" , combinedStates[iIndex].state);
		storeSubParameter('combined-states/' + esName + '/setTrigger/triggers/' +iIndex  + "/state" , sStateValue);
		storeSubParameter('combined-states/' + esName + '/resetTrigger/triggers/' +iIndex  + "/name" , combinedStates[iIndex].state);
		storeSubParameter('combined-states/' + esName + '/resetTrigger/triggers/' +iIndex  + "/state" , invertedStateValue);
		
		
	}
    storeSubParameter('combined-states/' + esName + '/name', Utf8.encode(unescape(oParameterObject.name)));
    storeSubParameter('combined-states/' + esName + '/setName', Utf8.encode(unescape(oParameterObject.setName)));
    storeSubParameter('combined-states/' + esName + '/resetName', Utf8.encode(unescape(oParameterObject.resetName)));
    storeSubParameter('combined-states/' + esName + '/showOnPhone', oParameterObject.showOnPhone);
    storeSubParameter('combined-states/' + esName + '/id', esName);

    storeSubParameter('combined-states/' + esName + '/setTrigger/actions/0/statename','' + esName);
    storeSubParameter('combined-states/' + esName + '/setTrigger/actions/0/type','change-addon-state');
    storeSubParameter('combined-states/' + esName + '/setTrigger/actions/0/addon-id','system-addon-user-defined-states');
	storeSubParameter('combined-states/' + esName + '/setTrigger/actions/0/state','active');
	storeSubParameter('combined-states/' + esName + '/setTrigger/actions/0/delay',0);

	storeSubParameter('combined-states/' + esName + '/resetTrigger/actions/0/statename','' + esName);
	storeSubParameter('combined-states/' + esName + '/resetTrigger/actions/0/type','change-addon-state');
	storeSubParameter('combined-states/' + esName + '/resetTrigger/actions/0/addon-id','system-addon-user-defined-states');
	storeSubParameter('combined-states/' + esName + '/resetTrigger/actions/0/state','inactive');
	storeSubParameter('combined-states/' + esName + '/resetTrigger/actions/0/delay',0);
    
}

function zoneSensorState(oParameterObject,esName) {
	var sActiveString;
	var sInactiveString;
	if (oParameterObject.sensorState.zone.greaterOnSet) {
		sActiveString='> ; ';
		sInactiveString='< ; ';
	} else {
		sInactiveString='> ; ';
		sActiveString='< ; ';
	} 
	
	var groupID=parseInt("" + oParameterObject.sensorState.zone.groupID);
	var oZone=getZoneByID(parseInt("" + oParameterObject.sensorState.zone.zoneID));
	var type=parseInt('' + oParameterObject.sensorState.zone.typeID);
	sActiveString+=oParameterObject.sensorState.zone.activeValue;
	sInactiveString+=oParameterObject.sensorState.zone.inactiveValue;
	
	storeSubParameter('zone-sensor-states/' + esName + '/name', Utf8.encode(unescape(oParameterObject.name)));
    storeSubParameter('zone-sensor-states/' + esName + '/setName', Utf8.encode(unescape(oParameterObject.setName)));
    storeSubParameter('zone-sensor-states/' + esName + '/resetName', Utf8.encode(unescape(oParameterObject.resetName)));
    storeSubParameter('zone-sensor-states/' + esName + '/showOnPhone', oParameterObject.showOnPhone);
    storeSubParameter('zone-sensor-states/' + esName + '/id', esName);
    storeSubParameter('zone-sensor-states/' + esName + '/source/zone',oParameterObject.sensorState.zone.zoneID); 
    storeSubParameter('zone-sensor-states/' + esName + '/source/group',groupID); 
    storeSubParameter('zone-sensor-states/' + esName + '/source/type',type);
    storeSubParameter('zone-sensor-states/' + esName + '/activeValue', sActiveString);
    storeSubParameter('zone-sensor-states/' + esName + '/inactiveValue', sInactiveString);
}


function deviceSensorState(oParameterObject,esName) {
	var sActiveString;
	var sInactiveString;
	if (oParameterObject.sensorState.device.greaterOnSet) {
		sActiveString='> ; ';
		sInactiveString='< ; ';
	} else {
		sInactiveString='> ; ';
		sActiveString='< ; ';
	} 
	
	var type=parseInt('' + oParameterObject.sensorState.device.typeID);
	sActiveString+=oParameterObject.sensorState.device.activeValue;
	sInactiveString+=oParameterObject.sensorState.device.inactiveValue;
	
		
    storeSubParameter('device-sensor-states/' + esName + '/name', Utf8.encode(unescape(oParameterObject.name)));
    storeSubParameter('device-sensor-states/' + esName + '/setName', Utf8.encode(unescape(oParameterObject.setName)));
    storeSubParameter('device-sensor-states/' + esName + '/resetName', Utf8.encode(unescape(oParameterObject.resetName)));
    storeSubParameter('device-sensor-states/' + esName + '/showOnPhone', oParameterObject.showOnPhone);
    storeSubParameter('device-sensor-states/' + esName + '/id', esName);
    storeSubParameter('device-sensor-states/' + esName + '/source/dsid',oParameterObject.sensorState.device.dsid); 
    storeSubParameter('device-sensor-states/' + esName + '/source/type',type);
    storeSubParameter('device-sensor-states/' + esName + '/activeValue', sActiveString);
    storeSubParameter('device-sensor-states/' + esName + '/inactiveValue', sInactiveString);
}

function powerLevelState(oParameterObject,esName,index) {
	lInfo.logln('setting powerstate ');
	
    storeSubParameter('power-states/' + esName + '/name', Utf8.encode(unescape(oParameterObject.name)));
    storeSubParameter('power-states/' + esName + '/setName', Utf8.encode(unescape(oParameterObject.setName)));
    storeSubParameter('power-states/' + esName + '/resetName', Utf8.encode(unescape(oParameterObject.resetName)));
    storeSubParameter('power-states/' + esName + '/showOnPhone', oParameterObject.showOnPhone);
    storeSubParameter('power-states/' + esName + '/id', esName);

    storeSubParameter('power-states/' + esName + '/source/dsid',oParameterObject.powerState.dsid); 
    storeSubParameter('power-states/' + esName + '/source/id',0); 
    storeSubParameter('power-states/' + esName + '/activeValue', oParameterObject.powerState.upperValue);
    storeSubParameter('power-states/' + esName + '/inactiveValue', oParameterObject.powerState.lowerValue);

	var reset=parseInt('' + oParameterObject.powerState.lowerValue,10);
	var set=parseInt('' + oParameterObject.powerState.upperValue,10);
	var dsm=getDSMeterByDSUID(oParameterObject.powerState.dsid);
	
	dsm.setPowerStateConfig(index,set,reset);
	
	
	storeSubParameter('power-states/' + esName + '/setTrigger/triggers/0/type' , "state-change");
	storeSubParameter('power-states/' + esName + '/setTrigger/triggers/0/name' , 'dsm.' + oParameterObject.powerState.dsid + '.' + index);
	storeSubParameter('power-states/' + esName + '/setTrigger/triggers/0/state' , "active");
	
    storeSubParameter('power-states/' + esName + '/setTrigger/actions/0/statename','' + esName);
    storeSubParameter('power-states/' + esName + '/setTrigger/actions/0/type','change-addon-state');
    storeSubParameter('power-states/' + esName + '/setTrigger/actions/0/addon-id','system-addon-user-defined-states');
	storeSubParameter('power-states/' + esName + '/setTrigger/actions/0/state','active');
	storeSubParameter('power-states/' + esName + '/setTrigger/actions/0/delay',0);

	storeSubParameter('power-states/' + esName + '/resetTrigger/triggers/0/type' , "state-change");
	storeSubParameter('power-states/' + esName + '/resetTrigger/triggers/0/name' , 'dsm.' + oParameterObject.powerState.dsid + '.' + index);
	storeSubParameter('power-states/' + esName + '/resetTrigger/triggers/0/state' , "inactive");
	
	storeSubParameter('power-states/' + esName + '/resetTrigger/actions/0/statename','' + esName);
	storeSubParameter('power-states/' + esName + '/resetTrigger/actions/0/type','change-addon-state');
	storeSubParameter('power-states/' + esName + '/resetTrigger/actions/0/addon-id','system-addon-user-defined-states');
	storeSubParameter('power-states/' + esName + '/resetTrigger/actions/0/state','inactive');
	storeSubParameter('power-states/' + esName + '/resetTrigger/actions/0/delay',0);

	if (oParameterObject.powerState.setRetriggeringLag>0) {	
		storeSubParameter('power-states/' + esName + '/setTrigger/damping/interval',oParameterObject.powerState.setRetriggeringLag);
		storeSubParameter('power-states/' + esName + '/setTrigger/damping/rewindTimer',true);
		storeSubParameter('power-states/' + esName + '/setTrigger/lag/delay',oParameterObject.powerState.setRetriggeringLag);
		storeSubParameter('power-states/' + esName + '/setTrigger/lag/reschedule',true);		
		storeSubParameter('power-states/' + esName + '/setTrigger/conditions/states/' + 'dsm.' + oParameterObject.powerState.dsid + '.' + index,'active');

	}
	if (oParameterObject.powerState.resetRetriggeringLag>0) {
		storeSubParameter('power-states/' + esName + '/resetTrigger/damping/interval',oParameterObject.powerState.resetRetriggeringLag);
		storeSubParameter('power-states/' + esName + '/resetTrigger/damping/rewindTimer',true);
		storeSubParameter('power-states/' + esName + '/resetTrigger/lag/delay',oParameterObject.powerState.resetRetriggeringLag);
		storeSubParameter('power-states/' + esName + '/resetTrigger/lag/reschedule',true);		
		storeSubParameter('power-states/' + esName + '/resetTrigger/conditions/states/' + 'dsm.' + oParameterObject.powerState.dsid + '.' + index,'inactive');
	} 

}

function consumptionState(oParameterObject,esName) {
    storeSubParameter('consumption-states/' + esName + '/name', Utf8.encode(unescape(oParameterObject.name)));
    storeSubParameter('consumption-states/' + esName + '/setName', Utf8.encode(unescape(oParameterObject.setName)));
    storeSubParameter('consumption-states/' + esName + '/resetName', Utf8.encode(unescape(oParameterObject.resetName)));
    storeSubParameter('consumption-states/' + esName + '/showOnPhone', oParameterObject.showOnPhone);
    storeSubParameter('consumption-states/' + esName + '/id', esName);
    
	storeSubParameter('consumption-states/' + esName + '/setTrigger/triggers/0/type' , "device-sensor");
	storeSubParameter('consumption-states/' + esName + '/setTrigger/triggers/0/dsuid' , oParameterObject.consumptionState.dSID);
	storeSubParameter('consumption-states/' + esName + '/setTrigger/triggers/0/eventid' , "event0");
	if (oParameterObject.consumptionState.setRetriggeringLag>0) {	
		storeSubParameter('consumption-states/' + esName + '/setTrigger/damping/interval',oParameterObject.consumptionState.setRetriggeringLag);
		storeSubParameter('consumption-states/' + esName + '/setTrigger/damping/rewindTimer',true);
		storeSubParameter('consumption-states/' + esName + '/setTrigger/lag/delay',oParameterObject.consumptionState.setRetriggeringLag);
		storeSubParameter('consumption-states/' + esName + '/setTrigger/lag/reschedule',true);		
	}
	storeSubParameter('consumption-states/' + esName + '/resetTrigger/triggers/0/type' , "device-sensor");
	storeSubParameter('consumption-states/' + esName + '/resetTrigger/triggers/0/dsuid' , oParameterObject.consumptionState.dSID);
	storeSubParameter('consumption-states/' + esName + '/resetTrigger/triggers/0/eventid' , "event1");
	if (oParameterObject.consumptionState.resetRetriggeringLag>0) {
		storeSubParameter('consumption-states/' + esName + '/resetTrigger/damping/interval',oParameterObject.consumptionState.resetRetriggeringLag);
		storeSubParameter('consumption-states/' + esName + '/resetTrigger/damping/rewindTimer',true);
		storeSubParameter('consumption-states/' + esName + '/resetTrigger/lag/delay',oParameterObject.consumptionState.resetRetriggeringLag);
		storeSubParameter('consumption-states/' + esName + '/resetTrigger/lag/reschedule',true);		
	}    
    storeSubParameter('consumption-states/' + esName + '/setTrigger/actions/0/statename','' + esName);
    storeSubParameter('consumption-states/' + esName + '/setTrigger/actions/0/type','change-addon-state');
    storeSubParameter('consumption-states/' + esName + '/setTrigger/actions/0/addon-id','system-addon-user-defined-states');
	storeSubParameter('consumption-states/' + esName + '/setTrigger/actions/0/state','active');
	storeSubParameter('consumption-states/' + esName + '/setTrigger/actions/0/delay',0);

	storeSubParameter('consumption-states/' + esName + '/resetTrigger/actions/0/statename','' + esName);
	storeSubParameter('consumption-states/' + esName + '/resetTrigger/actions/0/type','change-addon-state');
	storeSubParameter('consumption-states/' + esName + '/resetTrigger/actions/0/addon-id','system-addon-user-defined-states');
	storeSubParameter('consumption-states/' + esName + '/resetTrigger/actions/0/state','inactive');
	storeSubParameter('consumption-states/' + esName + '/resetTrigger/actions/0/delay',0);

}

function windowState(oParameterObject,esName) {
    storeSubParameter('window-states/' + esName + '/name', Utf8.encode(unescape(oParameterObject.name)));
    storeSubParameter('window-states/' + esName + '/setName', Utf8.encode(unescape(oParameterObject.setName)));
    storeSubParameter('window-states/' + esName + '/resetName', Utf8.encode(unescape(oParameterObject.resetName)));
    storeSubParameter('window-states/' + esName + '/showOnPhone', oParameterObject.showOnPhone);
    storeSubParameter('window-states/' + esName + '/id', esName);
    if (oParameterObject.windowState!=null) {
    	for (var iIndex=0;iIndex<oParameterObject.windowState.length;iIndex++) {
    		
    		var state=oParameterObject.windowState[iIndex].state;
    		var dsid='dev.' + oParameterObject.windowState[iIndex].dsid + '.0';
    		var helper=oParameterObject.windowState[iIndex].dsid + '_' +  state;
    		lInfo.logln('Window: ' + oParameterObject.windowState[iIndex].dsid + ' should be ' + state);
    		
    		var type=Property.getProperty('/apartment/zones/zone0/devices/' + oParameterObject.windowState[iIndex].dsid + '/binaryInputs/binaryInput0/inputType');
    		var sOpenString='inactive';
    		var sCloseString='active';
    		if (type==15) {
    			sOpenString='open';
    			sCloseString='closed';
    		}
			storeSubParameter('window-states/' + esName + '/setTrigger/triggers/' + iIndex + "/type" , 'addon-state-change');
    		storeSubParameter('window-states/' + esName + '/setTrigger/triggers/' + iIndex + "/addon-id" , 'system-addon-user-defined-states-helper');
    		storeSubParameter('window-states/' + esName + '/setTrigger/triggers/' + iIndex + "/name" , helper);
    		storeSubParameter('window-states/' + esName + '/setTrigger/triggers/' + iIndex + "/state" , 'active');
    		
			storeSubParameter('window-states/' + esName + '/resetTrigger/triggers/' + iIndex + "/type" , 'addon-state-change');
    		storeSubParameter('window-states/' + esName + '/resetTrigger/triggers/' + iIndex + "/addon-id" , 'system-addon-user-defined-states-helper');
    		storeSubParameter('window-states/' + esName + '/resetTrigger/triggers/' + iIndex + "/name" , helper);
    		storeSubParameter('window-states/' + esName + '/resetTrigger/triggers/' + iIndex + "/state" , 'inactive');
    		storeSubParameter('window-states/' + esName + '/resetTrigger/conditions/addon-states/system-addon-user-defined-states-helper/'+helper, '2');
    		
    		if ((state=='open') || (state=='open-tilded')) {
    			storeSubParameter('window-states/' + esName + '/helper/' + iIndex + "/setTrigger/triggers/0/type" , 'state-change');
	    		storeSubParameter('window-states/' + esName + '/helper/' + iIndex + "/setTrigger/triggers/0/name" , dsid);
	    		storeSubParameter('window-states/' + esName + '/helper/' + iIndex + "/setTrigger/triggers/0/state" , sOpenString);
    		}
    		if ((state=='closed') || (state=='closed-tilded')) { 
    			storeSubParameter('window-states/' + esName + '/helper/' + iIndex + "/setTrigger/triggers/0/type" , 'state-change');
	    		storeSubParameter('window-states/' + esName + '/helper/' + iIndex + "/setTrigger/triggers/0/name" , dsid);
	    		storeSubParameter('window-states/' + esName + '/helper/' + iIndex + "/setTrigger/triggers/0/state" , sCloseString);
    		}
    		if ((state=='open-tilded') ||(state=='closed-tilded')) {
    			storeSubParameter('window-states/' + esName + '/helper/' + iIndex + "/setTrigger/triggers/t_0/type" , 'state-change');
	    		storeSubParameter('window-states/' + esName + '/helper/' + iIndex + "/setTrigger/triggers/t_0/name" , dsid);
	    		storeSubParameter('window-states/' + esName + '/helper/' + iIndex + "/setTrigger/triggers/t_0/state" , 'tilded');
    		}

    		if ((state=='open') || (state=='open-tilded')) {
    			storeSubParameter('window-states/' + esName + '/helper/' + iIndex + "/resetTrigger/triggers/0/type" , 'state-change');
	    		storeSubParameter('window-states/' + esName + '/helper/' + iIndex + "/resetTrigger/triggers/0/name" , dsid);
	    		storeSubParameter('window-states/' + esName + '/helper/' + iIndex + "/resetTrigger/triggers/0/state" , sCloseString);
    		}
    		if ((state=='closed') || (state=='closed-tilded')) { 
    			storeSubParameter('window-states/' + esName + '/helper/' + iIndex + "/resetTrigger/triggers/0/type" , 'state-change');
	    		storeSubParameter('window-states/' + esName + '/helper/' + iIndex + "/resetTrigger/triggers/0/name" , dsid);
	    		storeSubParameter('window-states/' + esName + '/helper/' + iIndex + "/resetTrigger/triggers/0/state" , sOpenString);
    		}
    		if ((state=='open') ||(state=='closed')) {
    			storeSubParameter('window-states/' + esName + '/helper/' + iIndex + "/resetTrigger/triggers/t_0/type" , 'state-change');
	    		storeSubParameter('window-states/' + esName + '/helper/' + iIndex + "/resetTrigger/triggers/t_0/name" , dsid);
	    		storeSubParameter('window-states/' + esName + '/helper/' + iIndex + "/resetTrigger/triggers/t_0/state" , 'tilded');
    		}
    	    storeSubParameter('window-states/' + esName + '/helper/' + iIndex + '/setTrigger/actions/0/statename',helper);
    	    storeSubParameter('window-states/' + esName + '/helper/' + iIndex + '/setTrigger/actions/0/type','change-addon-state');
    	    storeSubParameter('window-states/' + esName + '/helper/' + iIndex + '/setTrigger/actions/0/addon-id','system-addon-user-defined-states-helper');
    		storeSubParameter('window-states/' + esName + '/helper/' + iIndex + '/setTrigger/actions/0/state','active');
    		storeSubParameter('window-states/' + esName + '/helper/' + iIndex + '/setTrigger/actions/0/delay',0);

    		storeSubParameter('window-states/' + esName + '/helper/' + iIndex + '/resetTrigger/actions/0/statename',helper);
    		storeSubParameter('window-states/' + esName + '/helper/' + iIndex + '/resetTrigger/actions/0/type','change-addon-state');
    		storeSubParameter('window-states/' + esName + '/helper/' + iIndex + '/resetTrigger/actions/0/addon-id','system-addon-user-defined-states-helper');
    		storeSubParameter('window-states/' + esName + '/helper/' + iIndex + '/resetTrigger/actions/0/state','inactive');
    		storeSubParameter('window-states/' + esName + '/helper/' + iIndex + '/resetTrigger/actions/0/delay',0);
    		
    	}
    }
    storeSubParameter('window-states/' + esName + '/setTrigger/actions/0/statename','' + esName);
    storeSubParameter('window-states/' + esName + '/setTrigger/actions/0/type','change-addon-state');
    storeSubParameter('window-states/' + esName + '/setTrigger/actions/0/addon-id','system-addon-user-defined-states');
	storeSubParameter('window-states/' + esName + '/setTrigger/actions/0/state','active');
	storeSubParameter('window-states/' + esName + '/setTrigger/actions/0/delay',0);

	storeSubParameter('window-states/' + esName + '/resetTrigger/actions/0/statename','' + esName);
	storeSubParameter('window-states/' + esName + '/resetTrigger/actions/0/type','change-addon-state');
	storeSubParameter('window-states/' + esName + '/resetTrigger/actions/0/addon-id','system-addon-user-defined-states');
	storeSubParameter('window-states/' + esName + '/resetTrigger/actions/0/state','inactive');
	storeSubParameter('window-states/' + esName + '/resetTrigger/actions/0/delay',0);
	
}

function removeSensor(esName) {
    var baseNode = Property.getNode('/scripts/system-addon-user-defined-states/device-sensor-states');
    if (baseNode != null) {
    	var stateName=esName;
        if (Property.getNode('/scripts/system-addon-user-defined-states/device-sensor-states/' + esName)!=null)
        	stateName=Property.getProperty('/scripts/system-addon-user-defined-states/device-sensor-states/'+esName+'/completeName');
        try {
        	unregisterStateSensor(stateName);
        } catch (e) {
        	lInfo.logln('could not deregister state ' + stateName + " " + e);
        }
        baseNode.removeChild(esName);        	
    }
    
    var baseNode = Property.getNode('/scripts/system-addon-user-defined-states/zone-sensor-states');
    if (baseNode != null) {
    	var stateName=esName;
    	if (Property.getNode('/scripts/system-addon-user-defined-states/zone-sensor-states/' + esName)!=null)
    		stateName=Property.getProperty('/scripts/system-addon-user-defined-states/zone-sensor-states/'+esName+'/completeName');
    	try {
	        unregisterStateSensor(stateName);
	    } catch (e) {
	    	lInfo.logln('could not deregister state ' + stateName + " " + e);
	    }
	    baseNode.removeChild(esName);        		        	
    }
}

function storeValue(sParameterString) {
    try {
        var oParameterObject = JSON.parse(unescape(sParameterString));
        
        var idValue = null;
        if (oParameterObject.showOnPhone==null)
        	oParameterObject.showOnPhone=true;
        if (oParameterObject.id != null) {
            idValue = oParameterObject.id;
        } else
            idValue = getNewIdValue();

        var esName = "" + idValue;

        var index=0;
        if (oParameterObject.type=='power-states'){
        	lInfo.logln('determinate index');
        	if (oParameterObject.id == null) {
        		lInfo.logln('find new index');
        		if (Property.getNode('power-states')!=null) {
        			var oArray=Property.getNode('power-states').getChildren();
        			var idInUse=[];
        			for (var pIndex=0;pIndex<oArray.length;pIndex++) {
        				var dsid=oArray[pIndex].getChild('source/dsid').getValue();
        				lInfo.logln('looking into ' + oArray[pIndex].getPath() + ' found dsm ' + dsid);
        				if (dsid==oParameterObject.powerState.dsid) {
        					idInUse.push(oArray[pIndex].getChild('source/id').getValue());
        					lInfo.logln('found index ' + oArray[pIndex].getChild('source/id').getValue());
        				}
        			}
        			while ((index<16)&&(idInUse.indexOf(index)>-1))
        				index++;
        			lInfo.logln('using Index '+ index);
        		}
        	} else
	        	if (Property.getNode('power-states/' + esName + '/source/id')!=null)
	    			index=Property.getProperty('power-states/' + esName + '/source/id');        	
        }
        
        var baseNode = Property.getNode('/scripts/system-addon-user-defined-states/custom-states');
        if (baseNode != null)
            baseNode.removeChild(esName);
        baseNode = Property.getNode('/scripts/system-addon-user-defined-states/triggered-states');
        if (baseNode != null) {
            baseNode.removeChild(esName);
            unregisterTrigger('/scripts/system-addon-user-defined-states/triggered-states/' + esName + '/setTrigger');
            unregisterTrigger('/scripts/system-addon-user-defined-states/triggered-states/' + esName + '/resetTrigger');
        }
        baseNode = Property.getNode('/scripts/system-addon-user-defined-states/combined-states');
        if (baseNode != null) {
            baseNode.removeChild(esName);
            unregisterTrigger('/scripts/system-addon-user-defined-states/combined-states/' + esName + '/setTrigger');
            unregisterTrigger('/scripts/system-addon-user-defined-states/combined-states/' + esName + '/resetTrigger');
        }
        
        baseNode = Property.getNode('/scripts/system-addon-user-defined-states/window-states');
        if (baseNode != null) {
        	
        	if (Property.getNode('/scripts/system-addon-user-defined-states/window-states/' + esName + '/helper')!= null) {        	
	        	var helperNodes=Property.getNode('/scripts/system-addon-user-defined-states/window-states/' + esName + '/helper').getChildren();
	        	for (var iIndex=0;iIndex<helperNodes.length;iIndex++) {
	        		unregisterTrigger(helperNodes[iIndex].getPath() + '/setTrigger');
	        		unregisterTrigger(helperNodes[iIndex].getPath() + '/resetTrigger');
	        	}
        	}
        	
            baseNode.removeChild(esName);
            unregisterTrigger('/scripts/system-addon-user-defined-states/window-states/' + esName + '/setTrigger');
            unregisterTrigger('/scripts/system-addon-user-defined-states/window-states/' + esName + '/resetTrigger');
        }
        
        
        baseNode = Property.getNode('/scripts/system-addon-user-defined-states/power-states');
        if (baseNode != null) {
            baseNode.removeChild(esName);
            unregisterTrigger('/scripts/system-addon-user-defined-states/power-states/' + esName + '/setTrigger');
            unregisterTrigger('/scripts/system-addon-user-defined-states/power-states/' + esName + '/resetTrigger');
        }
        
        
        removeSensor(esName);
                     
        if (oParameterObject.type=='custom-states') {
        	customStates(oParameterObject,esName);
        }
        if (oParameterObject.type=='triggered-states') {
        	triggeredStates(oParameterObject,esName);
        }
        if (oParameterObject.type=='combined-states')
        	combinateState(oParameterObject,esName);
        if (oParameterObject.type=='consumption-states')
        	consumptionState(oParameterObject,esName);
        if (oParameterObject.type=='power-states'){
        	powerLevelState(oParameterObject,esName,index);
        }
        if ((oParameterObject.type=='zone-sensor-states') || (oParameterObject.type=='device-sensor-states')) {
        	if (oParameterObject.sensorState.zone!=null)
        		zoneSensorState(oParameterObject,esName);
        	if (oParameterObject.sensorState.device!=null)
        		deviceSensorState(oParameterObject,esName);
        }
        	
        if (oParameterObject.type=='window-states')
        	windowState(oParameterObject,esName);
        Property.store();
        return esName;
    } catch (e) {
    	lWarn.logln("Fehler beim Speichern: " + e);
        for ( var i in e) {
        	lWarn.logln(i + ': ' + e[i]);
        }
        return null;
    }
}


function syncDeviceSensorState() {
	lInfo.logln("syncDeviceState");
	var oStateZones=Property.getNode('device-sensor-states');
	if (oStateZones==null)
		return;
	var oArray=oStateZones.getChildren();
	if (oArray.length==0)
		return;
	for (var iIndex=0;iIndex<oArray.length;iIndex++) {
		
		var stateName="0";		
		if (oArray[iIndex].getChild('completeName')!=null)
			stateName=oArray[iIndex].getChild('completeName');

		if (Property.getNode('/usr/addon-states/system-addon-user-defined-states/' + stateName)==null) {
	    	var sActiveString=oArray[iIndex].getChild('activeValue').getValue();
	    	var sInactiveString=oArray[iIndex].getChild('inactiveValue').getValue();
	    	var esName=oArray[iIndex].getChild('id').getValue();
	    	var oDevice=getDevices().byDSUID(oArray[iIndex].getChild('source/dsid').getValue());
	    	var type=oArray[iIndex].getChild('source/type').getValue();
	    	stateName=oDevice.addStateSensor(type,sActiveString,sInactiveString,esName);	    			
	    	Property.setProperty(oArray[iIndex].getPath()+'/completeName',stateName);
		}
		Property.setProperty('/usr/addon-states/system-addon-user-defined-states/' + stateName + '/type','device-sensor-states');
		Property.setProperty('/usr/addon-states/system-addon-user-defined-states/' + stateName + '/displayName',oArray[iIndex].getChild('name').getValue());
		Property.setProperty('/usr/addon-states/system-addon-user-defined-states/' + stateName + '/setName',oArray[iIndex].getChild('setName').getValue());
		Property.setProperty('/usr/addon-states/system-addon-user-defined-states/' + stateName + '/resetName',oArray[iIndex].getChild('resetName').getValue());
		Property.setProperty('/usr/addon-states/system-addon-user-defined-states/' + stateName + '/showOnPhone',oArray[iIndex].getChild('showOnPhone').getValue());
	}
	
}

function syncZoneSensorState() {
	lInfo.logln("syncZoneState");
	var oStateZones=Property.getNode('zone-sensor-states');
	if (oStateZones==null)
		return;
	var oArray=oStateZones.getChildren();
	if (oArray.length==0)
		return;
	for (var iIndex=0;iIndex<oArray.length;iIndex++) {
		
		var stateName="0";
		if (oArray[iIndex].getChild('completeName')!=null)
			stateName=oArray[iIndex].getChild('completeName');
		
		if (Property.getNode('/usr/addon-states/system-addon-user-defined-states/' + stateName)==null) {
	    	var sActiveString=oArray[iIndex].getChild('activeValue').getValue();
	    	var sInactiveString=oArray[iIndex].getChild('inactiveValue').getValue();	    	
	    	var esName=oArray[iIndex].getChild('id').getValue();
	    	var oZone=getZoneByID(oArray[iIndex].getChild('source/zone').getValue());
	    	var groupID=oArray[iIndex].getChild('source/group').getValue();
	    	var type=oArray[iIndex].getChild('source/type').getValue();
			
	    	stateName=oZone.addStateSensor(groupID,type,sActiveString,sInactiveString,esName);	 
	    	lInfo.logln('complete name: ' + oArray[iIndex].getPath()+'/completeName for ' + stateName )
	    	Property.setProperty(oArray[iIndex].getPath()+'/completeName',stateName);
		}
		Property.setProperty('/usr/addon-states/system-addon-user-defined-states/' + stateName + '/type','zone-sensor-states');
		Property.setProperty('/usr/addon-states/system-addon-user-defined-states/' + stateName + '/displayName',oArray[iIndex].getChild('name').getValue());
		Property.setProperty('/usr/addon-states/system-addon-user-defined-states/' + stateName + '/setName',oArray[iIndex].getChild('setName').getValue());
		Property.setProperty('/usr/addon-states/system-addon-user-defined-states/' + stateName + '/resetName',oArray[iIndex].getChild('resetName').getValue());
		Property.setProperty('/usr/addon-states/system-addon-user-defined-states/' + stateName + '/showOnPhone',oArray[iIndex].getChild('showOnPhone').getValue());
	}
	
}

function registerMyTrigger(baseNode,type) {
	if (type=='custom-states')
		return;
	var oRegistered=Property.getNode('/usr/triggers').getChildren();
	for (var iIndex=0;iIndex<oRegistered.length;iIndex++)
		if (oRegistered[iIndex].getChild('triggerPath').getValue()==baseNode.getPath() + '/setTrigger') {
			lInfo.logln('found trigger for ' + baseNode.getPath() +' so skipping');
			return;
		}
	lInfo.logln('make trigger register for ' + baseNode.getPath());
	registerTrigger(baseNode.getPath() + '/setTrigger','action_execute',{});
	registerTrigger(baseNode.getPath() + '/resetTrigger','action_execute',{});
	
	if (type=='window-states') {
		var helperNodes=Property.getNode(baseNode.getPath() + '/helper').getChildren();
		for (var iIndex=0;iIndex<helperNodes.length;iIndex++) {
			lInfo.logln('register subtrigger ' + helperNodes[iIndex].getPath());
			registerTrigger(helperNodes[iIndex].getPath() + '/setTrigger','action_execute',{});
			registerTrigger(helperNodes[iIndex].getPath() + '/resetTrigger','action_execute',{});
		}
	}
	if (type=='combined-states') {
		if (Property.getNode(baseNode.getPath() + '/helper')!=null) {
			var helperNodes=Property.getNode(baseNode.getPath() + '/helper').getChildren();
			for (var iIndex=0;iIndex<helperNodes.length;iIndex++) {
				lInfo.logln('register subtrigger ' + helperNodes[iIndex].getPath());
				registerTrigger(helperNodes[iIndex].getPath() + '/setTrigger','action_execute',{});
				registerTrigger(helperNodes[iIndex].getPath() + '/resetTrigger','action_execute',{});
			}
		}
	}
}

function syncSimpleStates (baseNode) {
	if (baseNode==null) {
		return;		
	}		
	lInfo.logln("syncState " + baseNode.getName());
    if (baseNode!=null) {
	    var oStates=baseNode.getChildren();
	    lInfo.logln("UDS-Config #" + oStates.length  + " von " + oStates);
		for (var iIndex=0;iIndex<oStates.length;iIndex++) {
			var oStateNode=oStates[iIndex];
			lInfo.logln("UDS-Config #" + oStateNode.getPath()  + " von " + oStates.length);
			var sID=oStateNode.getChild('id').getValue();
			lInfo.logln("prop "+ sID+" values " + Property.getProperty('/usr/addon-states/system-addon-user-defines-states/' + sID));
			if (Property.getProperty('/usr/addon-states/system-addon-user-defines-states/' + sID)==null) {
				lInfo.logln("register ding");
				try {
					registerState('' + sID,true);
				} catch (e) {
					lWarn.logln("error: " + e);
				}
			}
			Property.setProperty('/usr/addon-states/system-addon-user-defined-states/' + sID + '/type',baseNode.getName());
			Property.setProperty('/usr/addon-states/system-addon-user-defined-states/' + sID + '/displayName',oStateNode.getChild('name').getValue());
			Property.setProperty('/usr/addon-states/system-addon-user-defined-states/' + sID + '/setName',oStateNode.getChild('setName').getValue());
			Property.setProperty('/usr/addon-states/system-addon-user-defined-states/' + sID + '/resetName',oStateNode.getChild('resetName').getValue());
			Property.setProperty('/usr/addon-states/system-addon-user-defined-states/' + sID + '/showOnPhone',oStateNode.getChild('showOnPhone').getValue());
			registerMyTrigger(oStateNode,baseNode.getName());
		}
    }
}

function syncStates () {
	try {
		lInfo.logln('starting Sync State');
		syncSimpleStates(Property.getNode('custom-states'));
		syncSimpleStates(Property.getNode('triggered-states'));
		syncSimpleStates(Property.getNode('combined-states'));
		syncSimpleStates(Property.getNode('consumption-states'));
		syncSimpleStates(Property.getNode('window-states'));
		syncSimpleStates(Property.getNode('power-states'));
		syncDeviceSensorState();
		syncZoneSensorState();
		new Event('system-addon-user-defined-states.helper',{}).raise();
	} catch (e) {
		lWarn.logln('Error on SyncState '+e);
	}
}

function deleteState() {
	lInfo.logln("UDS-Config delete value " + raisedEvent.parameter.id);

    var oIDObject=JSON.parse(unescape(raisedEvent.parameter.id));
    if (typeof(oIDObject)!='object')
        oIDObject=[oIDObject];

    for (var sKey in oIDObject) {
    	lInfo.logln('removing ' + oIDObject[sKey]);
    	var stateName=oIDObject[sKey];

        var baseNode = Property.getNode('/scripts/system-addon-user-defined-states/entries');
        if (baseNode != null) {
            try {
            	unregisterState(stateName);
            } catch (e) {
            	lInfo.logln('could not deregister state ' + stateName + " " + e);
            }
            baseNode.removeChild(oIDObject[sKey]);                
        }


    	var baseNode = Property.getNode('/scripts/system-addon-user-defined-states/custom-states');
        if (baseNode != null) {
            try {
            	unregisterState(stateName);
            } catch (e) {
            	lInfo.logln('could not deregister state ' + stateName + " " + e);
            }
            baseNode.removeChild(oIDObject[sKey]);                
        }
        
        var baseNode = Property.getNode('/scripts/system-addon-user-defined-states/triggered-states');
        if (baseNode != null) {
            try {
            	unregisterState(stateName);
            } catch (e) {
            	lInfo.logln('could not deregister state ' + stateName + " " + e);
            }
            baseNode.removeChild(oIDObject[sKey]);                
            unregisterTrigger('/scripts/system-addon-user-defined-states/triggered-states/' + oIDObject[sKey] + '/setTrigger');
            unregisterTrigger('/scripts/system-addon-user-defined-states/triggered-states/' + oIDObject[sKey] + '/resetTrigger');            
        }
        
        var baseNode = Property.getNode('/scripts/system-addon-user-defined-states/consumption-states');
        if (baseNode != null) {
            try {
            	unregisterState(stateName);
            } catch (e) {
            	lInfo.logln('could not deregister state ' + stateName + " " + e);
            }
            baseNode.removeChild(oIDObject[sKey]);                
            unregisterTrigger('/scripts/system-addon-user-defined-states/consumption-states/' + oIDObject[sKey] + '/setTrigger');
            unregisterTrigger('/scripts/system-addon-user-defined-states/consumption-states/' + oIDObject[sKey] + '/resetTrigger');            
        }
        
        var baseNode = Property.getNode('/scripts/system-addon-user-defined-states/combined-states');
        if (baseNode != null) {
            try {
            	unregisterState(stateName);
            } catch (e) {
            	lInfo.logln('could not deregister state ' + stateName + " " + e);
            }
            baseNode.removeChild(oIDObject[sKey]);
            unregisterTrigger('/scripts/system-addon-user-defined-states/combined-states/' + oIDObject[sKey] + '/setTrigger');
            unregisterTrigger('/scripts/system-addon-user-defined-states/combined-states/' + oIDObject[sKey] + '/resetTrigger');            
        }
        
        var baseNode = Property.getNode('/scripts/system-addon-user-defined-states/device-sensor-states');
        if (baseNode != null) {
            if (Property.getNode('/scripts/system-addon-user-defined-states/device-sensor-states/' + stateName)!=null)
        		stateName=Property.getProperty('/scripts/system-addon-user-defined-states/device-sensor-states/'+stateName+'/completeName');
            try {
            	unregisterStateSensor(stateName);
            } catch (e) {
            	lInfo.logln('could not deregister state ' + stateName + " " + e);
            }
            baseNode.removeChild(oIDObject[sKey]);        	
        }
        
        var baseNode = Property.getNode('/scripts/system-addon-user-defined-states/zone-sensor-states');
        if (baseNode != null) {
        	if (Property.getNode('/scripts/system-addon-user-defined-states/zone-sensor-states/' + stateName)!=null)
        		stateName=Property.getProperty('/scripts/system-addon-user-defined-states/zone-sensor-states/'+stateName+'/completeName');
        	try {
		        unregisterStateSensor(stateName);
		    } catch (e) {
		    	lInfo.logln('could not deregister state ' + stateName + " " + e);
		    }
		    baseNode.removeChild(oIDObject[sKey]);        		        	
        }
        
        var baseNode = Property.getNode('/scripts/system-addon-user-defined-states/window-states');
        if (baseNode != null) {
            try {
            	unregisterState(stateName);
            } catch (e) {
            	lInfo.logln('could not deregister state ' + stateName + " " + e);
            }

        	if (Property.getNode('/scripts/system-addon-user-defined-states/window-states/' + oIDObject[sKey] + '/helper')!= null) {        	
	        	var helperNodes=Property.getNode('/scripts/system-addon-user-defined-states/window-states/' + oIDObject[sKey] + '/helper').getChildren();
	        	for (var iIndex=0;iIndex<helperNodes.length;iIndex++) {
	        		unregisterTrigger(helperNodes[iIndex].getPath() + '/setTrigger');
	        		unregisterTrigger(helperNodes[iIndex].getPath() + '/resetTrigger');
	        	}
        	}
            
            baseNode.removeChild(oIDObject[sKey]);        	
            unregisterTrigger('/scripts/system-addon-user-defined-states/window-states/' + oIDObject[sKey] + '/setTrigger');
            unregisterTrigger('/scripts/system-addon-user-defined-states/window-states/' + oIDObject[sKey] + '/resetTrigger');            
        }
        
        var baseNode = Property.getNode('/scripts/system-addon-user-defined-states/power-states');
        if (baseNode != null) {
            try {
            	unregisterState(stateName);
            } catch (e) {
            	lInfo.logln('could not deregister state ' + stateName + " " + e);
            }
            baseNode.removeChild(oIDObject[sKey]);        	
            unregisterTrigger('/scripts/system-addon-user-defined-states/power-states/' + oIDObject[sKey] + '/setTrigger');
            unregisterTrigger('/scripts/system-addon-user-defined-states/power-states/' + oIDObject[sKey] + '/resetTrigger');            
        }
    }

    Property.store();
    var evt = new Event("system-addon-user-defined-states.saved", {});
    evt.raise();	
}

function setShow(id,checked) {
	try {
	var baseNode=Property.getNode('/scripts/system-addon-user-defined-states');
	if (baseNode!=null){
		baseNode=baseNode.getChildren();
		if (baseNode!=null) {
			for (var iIndex=0;iIndex<baseNode.length;iIndex++) {
				if (baseNode[iIndex].getChild(id)!=null) {
					baseNode[iIndex].getChild(id).getChild('showOnPhone').setValue(checked);
					Property.store();
					syncStates();
					return;
				}
			}
		}
	}
	} catch (e) {
		
	}
}

function calcStateAll() {
	var baseChildren=Property.getNode('/usr/addon-states/system-addon-user-defined-states').getChildren();
	for (var iIndex=0;iIndex<baseChildren.length;iIndex++) {
		calcState(baseChildren.getName());
	}
}

function calcState(orgState) {	
	var baseProperty=Property.getNode('/usr/addon-states/system-addon-user-defined-states').getChildren();
	var baseState;
	for (var iIndex=0;iIndex<baseProperty.length;iIndex++) {
		if (baseProperty[iIndex].getName().indexOf(orgState)!=-1)
			baseState=baseProperty[iIndex].getName();
	}
	if (baseState==null)
		return;
	lInfo.logln('calc state ' + baseState);
	var type=Property.getProperty("/usr/addon-states/system-addon-user-defined-states/" + baseState + "/type");
	if (type=='custom-states')
		return false;
	if (type=='power-states')
		return false;
	if (type=='triggered-states')
		return false;
	if (type=='consumption-states')
		return false;

	if (type=='zone-sensor-states') {
		var zone=Property.getProperty('zone-sensor-states/'+orgState+'/source/zone');
		var group=Property.getProperty('zone-sensor-states/'+orgState+'/source/group');
		var type=Property.getProperty('zone-sensor-states/'+orgState+'/source/type');
		var oldNode=Property.getNode('/apartment/zones/zone' + zone + '/groups/group' + group + '/sensor/type' + type + '/sourcedsuid');
		if (oldNode!=null) {
			var dsuid;
			var oChildNode=Property.getNode('/apartment/zones/zone'+zone+'/devices').getChildren();
			for (var iIndex=0;iIndex<oChildNode.length;iIndex++) {
				if (oChildNode[iIndex].getName().substr(-8)==oldNode.getValue().substr(-8))
					dsuid=oChildNode[iIndex].getName();
			}
			lInfo.logln('found dsid ' + dsuid);
			if (dsuid==null)
				return;
			var oDevice=getDevices().byDSUID(dsuid);
			lInfo.logln('search for sensorinput');
			if (Property.getNode('/apartment/zones/zone0/devices/' + dsuid + '/sensorInputs')!=null) {
				var sensorInputs=Property.getNode('/apartment/zones/zone0/devices/' + dsuid + '/sensorInputs').getChildren();
				for (var iIndex=0;iIndex<sensorInputs.length;iIndex++){
					lInfo.logln('checking type index ' + iIndex + ' with ' + sensorInputs[iIndex].getChild('type').getValue() + ' against ' + type);
					if (sensorInputs[iIndex].getChild('type').getValue()==type) {
						lInfo.logln('make fetch');
						try {
							lInfo.logln('fetching value to trigger state ' + oDevice.getSensorValue(sensorInputs[iIndex].getChild('index').getValue()));
						} catch (e) {};
					}
				}
			} else lInfo.logln('device not found');

		}
		return false;
	}
		

	if (type=='device-sensor-states') {
		var dsid=Property.getProperty('device-sensor-states/'+orgState+'/source/dsid');
		var type=Property.getProperty('device-sensor-states/'+orgState+'/source/type');
		lInfo.logln('dsid ' + dsid + ' type ' + type);
		var oDevice=getDevices().byDSUID(dsid);
		if (Property.getNode('/apartment/zones/zone0/devices/' + dsid + '/sensorInputs')!=null) {
			var sensorInputs=Property.getNode('/apartment/zones/zone0/devices/' + dsid + '/sensorInputs').getChildren();
			for (var iIndex=0;iIndex<sensorInputs.length;iIndex++){
				lInfo.logln('checking type index ' + iIndex + ' with ' + sensorInputs[iIndex].getChild('type').getValue());
				if (sensorInputs[iIndex].getChild('type').getValue()==type) {
					try {
						lInfo.logln('fetching value to trigger state ' + oDevice.getSensorValue(sensorInputs[iIndex].getChild('index').getValue()));
					} catch (e) {};
				}
			}
		}
		return false;
	}
	if (type=='combined-states'){
		lInfo.logln('calc state for ' + baseState);
		var fOr=(Property.getNode('combined-states/' + baseState + '/setTrigger/conditions')==null);
		var oChild=Property.getNode('combined-states/' + baseState + '/setTrigger/triggers').getChildren();
		var fAndValue=true;
		var fOrValue=false;
		for (var iIndex=0;iIndex<oChild.length;iIndex++) {
			var name=oChild[iIndex].getChild('name').getValue();
			lInfo.logln('check state ' + name);
			if (oChild[iIndex].getChild('type').getValue()=='state-change') {
				var fValue=Property.getProperty('/usr/states/' + name + '/state');
				lInfo.logln('check value ' + fValue + " with target " + oChild[iIndex].getChild('state').getValue());
				if (oChild[iIndex].getChild('state').getValue()==fValue)
					fOrValue=true;				
				else 
					fAndValue=false;
			}
			if (oChild[iIndex].getChild('type').getValue()=='addon-state-change') {
				var addon=oChild[iIndex].getChild('addon-id').getValue();
				if (addon == 'system-addon-user-defined-states-helper') {
					var dsid=name.split('_')[1];
					var state=name.split('_')[2];
					var actualValue=Property.getProperty("/usr/states/dev." + dsid + '.0/state');
					lInfo.logln('check window value ' + dsid + '/' + state + " with target " + actualValue);		
					if (actualValue==state) {
						fOrValue=true;
						if (Property.getNode('combined-states/' + baseState + '/helper')!=null) {
							var oHelperChild=Property.getNode('combined-states/' + baseState + '/helper').getChildren();
							for (var jIndex=0;jIndex<oHelperChild.length;jIndex++) {
								if (oHelperChild[jIndex].getChild('setTrigger/actions/0/statename').getValue()==name) {
									lInfo.logln('execute ' + oHelperChild[jIndex].getChild('setTrigger').getPath());
									new Event('action_execute',{path:oHelperChild[jIndex].getChild('setTrigger').getPath()}).raise();
								}
							}
						}
					} else {
						fAndValue=false;
						if (Property.getNode('combined-states/' + baseState + '/helper')!=null) {						
							var oHelperChild=Property.getNode('combined-states/' + baseState + '/helper').getChildren();
							for (var jIndex=0;jIndex<oHelperChild.length;jIndex++) {
								if (oHelperChild[jIndex].getChild('resetTrigger/actions/0/statename').getValue()==name) {
									lInfo.logln('execute ' + oHelperChild[jIndex].getChild('resetTrigger').getPath());
									new Event('action_execute',{path:oHelperChild[jIndex].getChild('resetTrigger').getPath()}).raise();
								}
							}
						}
					}
				} else {
					lInfo.logln('check value ' + addon + '/' + name + " with target " + oChild[iIndex].getChild('state').getValue());		
					var fValue=Property.getProperty('/usr/addon-states/' + addon + '/' + name + '/state');
					if (oChild[iIndex].getChild('state').getValue()==fValue)
						fOrValue=true;				
					else 
						fAndValue=false;
				}
			}				
		}
		if (fOr) {
			if (fOrValue) {
				lInfo.logln('state '+baseState+' should be set');
				new Event('action_execute',{path:Property.getNode('combined-states/' + baseState).getPath()+'/setTrigger',time:'+1'}).raise();
			} else {
				lInfo.logln('state '+baseState+' should be reset');
				new Event('action_execute',{path:Property.getNode('combined-states/' + baseState).getPath()+'/resetTrigger',time:'+1'}).raise();
			}
		} else {
			if (fAndValue) {
				lInfo.logln('state '+baseState+' should be set');
				new Event('action_execute',{path:Property.getNode('combined-states/' + baseState).getPath()+'/setTrigger',time:'+1'}).raise();
			} else {
				lInfo.logln('state '+baseState+' should be reset');
				new Event('action_execute',{path:Property.getNode('combined-states/' + baseState).getPath()+'/resetTrigger',time:'+1'}).raise();
			}
		}
		return false;
	}
	

	if (type=='window-states') {
		lInfo.logln('checking a window-state ' + baseState);
		var oHelper=Property.getNode('window-states/' + baseState + '/helper').getChildren(); 
		for (var iIndex=0;iIndex<oHelper.length;iIndex++) {
			lInfo.logln('looking at helper ' +oHelper[iIndex].getName());
			var oChildNodes=oHelper[iIndex].getChild('setTrigger/triggers').getChildren();
			var fSet=false;
			for (var jIndex=0;jIndex<oChildNodes.length;jIndex++) {
				var dsid=oChildNodes[jIndex].getChild('name').getValue();
				var stateValue=oChildNodes[jIndex].getChild('state').getValue();
				lInfo.logln('found set trigger for ' + dsid + ' with val ' +stateValue);
				if (Property.getProperty('/usr/states/' + dsid + '/state')==stateValue) {
					fSet=true;
				}
			}
			if (fSet) {
				lInfo.logln('should be set ' + oHelper[iIndex].getPath()+'/setTrigger');
				new Event('action_execute',{path:oHelper[iIndex].getPath()+'/setTrigger'}).raise();
			} else {
				var fUnset=false;
				oChildNodes=oHelper[iIndex].getChild('resetTrigger/triggers').getChildren();
				for (var jIndex=0;jIndex<oChildNodes.length;jIndex++) {
					var dsid=oChildNodes[jIndex].getChild('name').getValue();
					var stateValue=oChildNodes[jIndex].getChild('state').getValue();
					lInfo.logln('found reset trigger for ' + dsid + ' with val ' +stateValue);
					if (Property.getProperty('/usr/states/' + dsid + '/state')==stateValue) {
						fUnset=true;
					}
				}
				if (fUnset) {
					lInfo.logln('should be reset ' + oHelper[iIndex].getPath()+'/resetTrigger');
					new Event('action_execute',{path:oHelper[iIndex].getPath()+'/resetTrigger'}).raise();
				}
			}			
		}
		
		lInfo.logln('checking the main state');
		
		var fSet=false;
		var oChildNodes=Property.getNode('window-states/' + baseState + '/setTrigger/triggers').getChildren();
		for (var jIndex=0;jIndex<oChildNodes.length;jIndex++) {
			var helper=oChildNodes[jIndex].getChild('name').getValue();
			lInfo.logln('found helper ' + helper);
			if (Property.getProperty('/usr/addon-states/system-addon-user-defined-states-helper/' + helper + '/state')=='active') {
				fSet=true;
			}
		}
		if (fSet) {
			lInfo.logln('state '+baseState+' should be set');
			new Event('action_execute',{path:Property.getNode('window-states/' + baseState).getPath()+'/setTrigger'}).raise();
			return true;
		} else {
			lInfo.logln('state '+baseState+' should be reset');
			new Event('action_execute',{path:Property.getNode('window-states/' + baseState).getPath()+'/resetTrigger'}).raise();
			return true;
		}			
	}		
	return false;
}

lInfo.logln("UDS-Config " + raisedEvent.name);
if (raisedEvent.name == 'system-addon-user-defined-states.config') {
	Property.load();
	lInfo.logln("UDS-Config param action " + raisedEvent.parameter.actions);
	if (raisedEvent.parameter.actions == 'setShowOnPhone') {
		Property.load();
		var id=raisedEvent.parameter.id;
		setShow(id,true);
        var evt = new Event("system-addon-user-defined-states.saved", {});
        Property.store();
        evt.raise();
	}
	if (raisedEvent.parameter.actions == 'resetShowOnPhone') {
		Property.load();
		var id=raisedEvent.parameter.id;
		setShow(id,false);
        var evt = new Event("system-addon-user-defined-states.saved", {});
        Property.store();
        evt.raise();
	}
	if (raisedEvent.parameter.actions == 'save') {
		Property.load();
    	lInfo.logln("UDS-Config param value " + raisedEvent.parameter.value);
        var id=storeValue(raisedEvent.parameter.value);
        syncStates();
        var fRecalc=false
        if (id!=null)
        	fRecalc=calcState(id);
        Property.store();
/*        if (fRecalc)
        	new Event("system-addon-user-defined-states.saved", {time:'+5'}).raise();
        else*/
        new Event("system-addon-user-defined-states.saved", {}).raise();
    }  
	if (raisedEvent.parameter.actions == 'syncState') {
		Property.load();
        syncStates();
    }  
    if (raisedEvent.parameter.actions == 'delete') {
    	deleteState();
    }
    if (raisedEvent.parameter.actions == 'calcState') {
    	if (raisedEvent.parameter.baseState!=null)
    		calcState(raisedEvent.parameter.baseState);
    	else
    		calcStateAll();
    }
} else if (raisedEvent.name == 'model_ready') {
    Property.load();
    syncStates();
    calcStateAll();
}
